--Pepperming Mining, logistic mining intended for use in scenarios.
--Written by Mylon, 2017
--MIT License
--Forked from Nougat Mining on 05/12/2017

peppermint = {
    POLLUTION = 0.3333,     --Miners generate 10/minute and mine 30 ore per minute.
    USE_WORKER_CARGO = true --This is too OP.
}
nougat = {}
MINING_TIME = 120 --Bots much spend this many ticks to pick up ore, modified by the ore's mining time.

-- old: global.peppermint["forcename"]["surfacename"]["oreposition"] = ore
-- new: global.peppermint["forcename"]["surfacename"]["chunkposition"]["oreposition"] = ore
global.peppermint = {}
-- old: global.peppermint["forcename"]["surfacename"] = "oreposition"
-- new: global.peppermint["forcename"]["surfacename"]["chunkposition"] = "oreposition"
global.picker = {} --per-surface level index.  Used to determine the next ore to mine.
global.nougat = { forces = {}, toggle = {}, easy_ores = {} }

global.entities = {} --array of form {game_tick, robot}
global.tick_tock = {}

function peppermint.mark(event)
    if event.item ~= "peppermint-tool" then return end
    local player = game.players[event.player_index]
    local force = player.force
    -- if not global.peppermint[force.name] then
    --     global.peppermint[force.name] = {}
    -- end
    -- if not global.peppermint[force.name][event.surface.name] then
    --     global.peppermint[force.name][event.surface.name] = {}
    -- end
    -- local minty = global.peppermint[force.name][event.surface.name]

    -- if event.area.left_top.x == event.area.right_bottom.x or event.area.left_top.y == event.area.right_bottom.y then
    --     --log("Selected area of size 0")
    --     return
    -- end

    local ores = player.surface.find_entities_filtered { type = "resource", area = event.area, limit = 10000 }
    --local ores = event.entities
    if #ores == 0 then return end

    if event.alt then --Remove, not add.
        local removed = false
        for k, v in pairs(ores) do
            if peppermint.remove(v, force.name) then
                removed = true
            end
        end
        if removed then
            player.print("Peppermint mining: Ores no longer flagged for mining.")
        end
        return
    end
    -- if event.alt then --Remove, not add.
    --     local removed = false
    --     for _, ore in pairs(ores) do
    --         for n = #minty.ores, 1, -1 do
    --             if ore == minty.ores[n] then
    --                 table.remove(minty.ores, n)
    --                 removed = true
    --             end
    --         end
    --     end
    --     if removed then
    --         player.print("Peppermint mining: Ores no longer flagged for mining.")
    --     end
    --     return
    -- end

    --Check to see if a miner got deconned.  If so, let's assume the player does NOT want to mark the ore for mining.
    -- local miners = player.surface.find_entities_filtered{type="mining-drill", area=event.area, force=player.force}
    -- for k, v in pairs(miners) do
    --     if v.to_be_deconstructed(player.force) then
    --         return
    --     end
    -- end

    --Filter out non-mineable ores.
    -- for i = #ores, 1, -1 do
    --     if ores[i].prototype.resource_category == "basic-fluid"
    --         or ores[i].prototype.mineable_properties.required_fluid
    --         or ores[i].prototype.infinite_resource then
    --             table.remove(ores, i)
    --     end
    -- end

    --Ensure that a roboport is in range and it's not a player roboport.
    -- for i = #ores, 1, -1 do
    --     local networks = player.surface.find_logistic_networks_by_construction_area(ores[i].position, force)
    --     if #networks == 0 then
    --         table.remove(ores, i)
    --     else
    --         local only_mobile = true
    --         for _, network in pairs(networks) do
    --             if not (network.valid and network.cells[1].valid) then
    --                 table.remove(ores, i)
    --             elseif not network.cells[1].mobile then
    --                 only_mobile = false
    --                 break
    --             end
    --         end
    --         if only_mobile then --The only network in range is the player's network.
    --             table.remove(ores, i)
    --         end
    --     end
    -- end

    --Check for duplicates and insert into table
    --Note, this is o(n^2)
    local added = false
    for k, v in pairs(ores) do
        if peppermint.add(v, force.name) then
            added = true
        end
    end
    -- for i = #ores, 1, -1 do
    --     local dupe = false
    --     for n = #minty.ores, 1, -1 do
    --         if ores[i] == minty.ores[n] then
    --             table.remove(ores, i)
    --             dupe = true
    --             break
    --         end
    --     end
    --     if not dupe then
    --         table.insert(minty.ores, ores[i])
    --         added = true
    --     end
    -- end
    if added then
        player.print("Peppermint Mining: Ores added for mining.")
    end
end

--Iterate over each force.
function peppermint.stretch()
    -- log("peppermint.stretch()")
    for forcename, surface in pairs(global.peppermint) do
        for surfacename, chunklist in pairs(surface) do
            for chunk, minty in pairs(chunklist) do
                peppermint.mine(forcename, surfacename, chunk)
            end
        end
    end
end

--Magic happens here.
function peppermint.mine(forcename, surfacename, chunk, prepromised)
    -- log("peppermint.mine()")
    local force = game.forces[forcename]
    prepromised = prepromised or 0
    if not (force and force.valid) then
        -- log("Force died!")
        global.peppermint[forcename] = nil
        return
    end
    local ore = peppermint.pick(forcename, surfacename, chunk)
    if not (ore and ore.valid) then
        -- log("ore not found or not valid")
        return
    end
    local surface = ore.surface
    local networks = surface.find_logistic_networks_by_construction_area(ore.position, force)
    if not networks then --Power died?  Roboport died?
        -- log("No network found.")
        return
    end
    local network
    for k, v in pairs(networks) do
        if v.valid and not v.cells[1].mobile then
            network = v
            break
        end
    end
    if not (network and network.valid) then
        -- log("network invalid.")
        return
    end
    --Check for low power
    local roboport = network.find_cell_closest_to(ore.position) and network.find_cell_closest_to(ore.position).owner
    if not roboport then --Something went wrong.
        -- log("Roboport or network invalid.")
        return
    end
    if roboport.prototype.electric_energy_source_prototype.buffer_capacity ~= roboport.energy then
        -- log("not enough capacity?")
        return
    end

    local count = math.floor(network.available_construction_robots / 1.5) - prepromised

    if count > 0 then
        mine(ore, count, force)
    end
end

function mine(ore, count, force)
    --Reused from Nougat Mining
    local position = ore.position --Just in case we kill the ore.
    local productivity = force.mining_drill_productivity_bonus + 1
    local cargo_multiplier = 1
    if peppermint.USE_WORKER_CARGO then
        cargo_multiplier = force.worker_robots_storage_bonus + 1
    end
    local products = {}

    --count = math.min(math.ceil(ore.amount / cargo_multiplier), peppermint.MAX_ITEMS, count)
    count = math.min(math.ceil(ore.amount / cargo_multiplier), count)

    --Modify force construction limit since this mod can easily spam more than enough requests!
    --This is on a per tick basis, and we check every 60 ticks.  This has to be greater than the count or we'll never catch up!
    if force.max_successful_attempts_per_tick_per_construction_queue * 60 < count then
        force.max_successful_attempts_per_tick_per_construction_queue = math.max(math.floor(count / 60),
            force.max_successful_attempts_per_tick_per_construction_queue)
    end

    if not ore.prototype.mineable_properties.required_fluid then
        for k, v in pairs(ore.prototype.mineable_properties.products) do
            local product
            if v.type == "item" then --If fluid, not sure what to do here.
                if v.amount then
                    product = { name = v.name, count = v.amount * count }
                elseif v.probability then
                    if math.random() < v.probability then
                        if v.amount_min ~= v.amount_max then
                            product = { name = v.name, count = math.random(v.amount_min * count, v.amount_max * count) }
                        else
                            product = { name = v.name, count = v.amount_max * count }
                        end
                    end
                else --Shouldn't have to use this.
                    product = { name = v.name, count = count }
                end
            end
            if product then
                product.count = product.count * cargo_multiplier
                table.insert(products, { name = product.name, count = product.count })
            end
        end
    else
        local item_name = ore.name .. "-taffy"
        if game.item_prototypes[item_name] then
            if not force.recipes[item_name].enabled then
                force.recipes[item_name].enabled = true
            end
            products = { { name = ore.name .. "-taffy", count = count } }
        else
            log("Invalid item for ore: " .. ore.name)
            return
        end
    end

    --for i = 1, count do
    for k, v in pairs(products) do
        if v.count >= 1 then
            ore.surface.spill_item_stack(position, v, false, force, false)
        end
        -- local oreitem = surface.create_entity{name="item-on-ground", stack=v, position=position}
        -- if oreitem and oreitem.valid then --Why is oreitem sometimes nil or invalid?
        --     oreitem.order_deconstruction(force)
        --game.print(oreitem.stack.name .. " #"..i.." created for pickup. ")
        -- end
    end
    --end
    --Also add pollution.  Mining productivity is omitted.
    ore.surface.pollute(position, peppermint.POLLUTION * count * cargo_multiplier)
    --Pollution is done on pickup!
    -- if game.entity_prototypes["construction-robot"] then
    --     game.pollution_statistics.on_flow("construction-robot", peppermint.POLLUTION * count * cargo_multiplier)
    -- end
    --game.print("Created " .. #products .. " for pickup.")

    --Add to productivity stats.
    for k, v in pairs(products) do
        force.item_production_statistics.on_flow(v.name, v.count)
    end

    local surfacename = ore.surface.name
    local oreamount = ore.amount

    --Deplete the ore.
    if ore.amount > math.ceil(count * cargo_multiplier / productivity) then
        ore.amount = ore.amount - math.ceil(count * cargo_multiplier / productivity)
    else
        ore.deplete()
        --Did we use less than 20% of the robots? Let's go again.
        if oreamount / (count / 5) * cargo_multiplier / productivity then
            peppermint.mine(force.name, surfacename, tochunk(position), count)
        end
    end
end

--Shuffle the table whenever we reset the index.
-- function peppermint.cook(ores)
--     local n = #ores
--     while n > 2 do
--         local k = math.random(n)
--         ores[n], ores[k] = ores[k], ores[n]
--         n = n - 1
--     end
-- end

function peppermint.is_tasty(ore, forcename)
    if ore.prototype.infinite_resource or not ore.prototype.mineable_properties then
        return false
    else
        if ore.prototype.mineable_properties.products then
            local has_item = false
            for k, v in pairs(ore.prototype.mineable_properties.products) do
                if v.type == "item" then
                    has_item = true
                end
            end
            if not has_item then return false end
        end
    end
    if string.find(ore.name, "placeholder") then return false end --Compatability for Prospector
    local networks = ore.surface.find_logistic_networks_by_construction_area(ore.position, game.forces[forcename])
    if #networks == 0 then
        return false
    else
        local only_mobile = true
        for _, network in pairs(networks) do
            if network and network.valid and not network.cells[1].mobile then
                only_mobile = false
                break
            end
        end
        if only_mobile then --The only network in range is the player's network.
            return false
        end
    end

    return true
end

--Getter/setters
--Primary table indexed by coords.
function peppermint.add(ore, forcename)
    if not peppermint.is_tasty(ore, forcename) then return end
    if not global.peppermint[forcename] then global.peppermint[forcename] = {} end
    if not global.peppermint[forcename][ore.surface.name] then global.peppermint[forcename][ore.surface.name] = {} end
    local chunk = tochunk(ore.position)
    if not global.peppermint[forcename][ore.surface.name][chunk] then global.peppermint[forcename][ore.surface.name][chunk] = {} end

    local minty = global.peppermint[forcename][ore.surface.name][chunk]

    local key = ore.position.x .. " " .. ore.position.y
    if not (minty[key] and minty[key].valid) then
        minty[key] = ore
        return true
    else
        return false
    end
end

function peppermint.remove(ore, forcename)
    local minty = global.peppermint[forcename] and
        global.peppermint[forcename][ore.surface.name] and
        global.peppermint[forcename][ore.surface.name][tochunk(ore.position)]
    if not minty then return end

    local key = ore.position.x .. " " .. ore.position.y
    if minty[key] then
        minty[key] = nil
        return true
    end

    return false
end

-- function peppermint.nom(event)
--     if not event.entity and not event.entity.valid then return end
--     local x, y = math.floor(event.entity.position.x), math.floor(event.entity.position.y)
--     for name, minty in pairs(global.peppermint) do
--         if minty.ores[x] and minty.ores[x][y] then
--             peppermint.remove(event.entity, name)
--         end
--     end
-- end

function peppermint.pick(forcename, surfacename, chunk)
    if not global.picker[forcename] then global.picker[forcename] = {} end
    if not global.picker[forcename][surfacename] then global.picker[forcename][surfacename] = {} end

    -- if no picker yet exists for chunks, initialize it with nil
    if not global.picker[forcename][surfacename][chunk] then global.picker[forcename][surfacename][chunk] = nil end
    -- if picker for chunk has an entry which does not exist anymore in peppermint (due to cleanup) change back to nil
    if global.picker[forcename][surfacename][chunk] and not global.picker[forcename][surfacename][chunk][global.picker[forcename][surfacename][chunk]] then global.picker[forcename][surfacename][chunk] = nil end

    -- log("current in picker: " .. global.picker[forcename][surfacename][chunk])
    -- log("chunk: " .. chunk)
    -- log("table: " .. serpent.block(global.peppermint[forcename][surfacename][chunk]))
    -- log("pick: " .. serpent.block(global.picker[forcename][surfacename][chunk]))

    local picked_index, ore = next(global.peppermint[forcename][surfacename][chunk],
        global.picker[forcename][surfacename][chunk])
    global.picker[forcename][surfacename][chunk] = picked_index

    if ore and ore.valid then
        -- log("ore will be logged after")
        -- log(ore.name)

        -- for i, v in ipairs(ore) do
        --     log("blubb: " .. i .. " " .. v)
        -- end

        return ore

        -- if ore.valid then
        --     return ore
        -- else
        --     -- ore position is not valid anymore
        --     --log("ore to be removed: " .. tostring(ore.valid))
        --     log("ore to be removed: " .. ore.surface.name)
        --     log("ore to be removed: " .. ore.position.x .. " " .. ore.position.y)
        --     --peppermint.remove(ore, forcename)
        -- end
    end
    if picked_index then
        -- log("picked_index " .. picked_index)
        --Scan position for another ore in case a mod swapped it.
        local comma, _ = string.find(picked_index, " ")
        local x = tonumber(string.sub(picked_index, 1, comma - 1))
        local y = tonumber(string.sub(picked_index, comma + 1))
        -- log("search again through" .. x .. " / " .. y)
        local new_ore = game.surfaces[surfacename].find_entities_filtered { type = "resource", position = { x, y } }
            [1]
        if new_ore and ore.valid then
            peppermint.add(new_ore, forcename)
            return new_ore
        end
        -- else there is still no ore we can clean up the entry
        global.peppermint[forcename][surfacename][chunk][picked_index] = nil

        -- if chunk is empty, remove also chunk
        -- in lua # and table.getn only count integer keys but we have strings
        for k, v in pairs(global.peppermint[forcename][surfacename][chunk]) do
            return
        end
        global.peppermint[forcename][surfacename][chunk] = nil
    end
    -- --Try again -- i don't think we need to, let it just loop to this again (if it still exists)
    -- if #global.peppermint[forcename][surfacename][chunk] > 1 then
    --     return peppermint.pick(forcename, surfacename, chunk)
    -- end
end

-- function peppermint.gc()
--     for forcename, surface in pairs(global.peppermint) do
--         for surfacename, chunklist in pairs(surface) do
--             for chunk, minty in pairs(chunklist) do
--                 if #minty > 1 then
--                     for key, ore in pairs(minty) do
--                         if not (ore.valid and peppermint.is_tasty(ore, forcename)) then
--                             minty[key] = nil
--                         end
--                     end
--                 else
--                     -- empty minty also removes chunk
--                     chunklist[chunk] = nil
--                 end
--             end
--         end
--     end
-- end

-- https://lua-api.factorio.com/latest/Concepts.html#ChunkPosition
-- A MapPosition can be translated to a ChunkPosition by dividing the x/y values by 32.
function tochunk(pos)
    return math.floor(pos.x / 32) .. " " .. math.floor(pos.y / 32)
end

function nougat.stretch()
    if not settings.global["nougat mode"].value then return end
    for forcename, force in pairs(global.nougat.forces) do
        local roboport = force.roboports[force.index]
        if roboport then
            if nougat.chewy(roboport) == false then --Roboport is no longer a valid miner.
                --game.print("Nougat: removing roboport")
                table.remove(force.roboports, force.index)
            else
                force.index = force.index + 1
            end
        else
            force.index = 1
        end
    end
end

function nougat.chewy(roboport)
    if not roboport.valid then return false end
    --local roboport = global.nougat.roboports[index]
    if not (roboport.prototype.electric_energy_source_prototype.buffer_capacity == roboport.energy) then --Low power
        return
    end
    if not (roboport.logistic_cell and roboport.logistic_cell.valid and roboport.logistic_cell.logistic_network) then --Not powered.
        return
    end
    local radius = nougat.how_many_licks(roboport)
    --In case an update changes a roboport...
    if not radius or radius == 0 then
        return false
    end
    local area = { { roboport.position.x - radius, roboport.position.y - radius },
        { roboport.position.x + radius - 1, roboport.position.y + radius - 1 } }
    local ore = roboport.surface.find_entities_filtered { name = global.nougat.easy_ores, limit = 1, area = area }[1]
    if not (ore and ore.valid) then
        --There must be nothing left to mine.
        return false
    end
    --game.print("Removing roboport.  No ore found.")
    assigned = assigned or 0 --In case this is the first time we're calling it.
    --local count = nougat.oompa_loompa(roboport.logistic_cell.logistic_network) - assigned
    local count = roboport.logistic_cell.logistic_network.available_construction_robots
    local force = roboport.force
    if count < 30 then
        return
    end

    --Finally, let's do some mining.
    mine(ore, count, force)

    do return end
    --Post unification code.  This can probably be discarded.

    local position = ore.position --Just in case we kill the ore.
    local surface = roboport.surface
    local productivity = force.mining_drill_productivity_bonus + 1
    local cargo_multiplier = 1
    if nougat.USE_CARGO_COUNT then
        cargo_multiplier = force.worker_robots_storage_bonus + 1
    end
    local products = {}

    --count = math.min(math.ceil(ore.amount / cargo_multiplier), nougat.MAX_ITEMS, count)
    count = math.min(math.ceil(ore.amount / cargo_multiplier), count)

    for k, v in pairs(ore.prototype.mineable_properties.products) do
        local product
        if v.type == "item" then --If fluid, not sure what to do here.
            if v.amount then
                product = { name = v.name, count = v.amount * count }
            elseif v.probability then
                if math.random() < v.probability then
                    if v.amount_min ~= v.amount_max then
                        product = { name = v.name, count = math.random(v.amount_min * count, v.amount_max * count) }
                    else
                        product = { name = v.name, count = v.amount_max * count }
                    end
                end
            else --Shouldn't have to use this.
                product = { name = v.name, count = count }
            end
        end
        if product then
            product.count = product.count * cargo_multiplier

            table.insert(products, { name = product.name, count = product.count })
        end
    end
end

--Borrowed from Everbuild 0.9.3
function delay_deconstruction(event)
    local robot = event.robot
    local entity = event.entity
    if not global.items[entity.stack.name] then return end
    local time_to_mine = (global.items[entity.stack.name]) * MINING_TIME
    if robot.prototype.energy_per_tick then
        robot.energy = robot.energy - robot.prototype.energy_per_tick * time_to_mine
    end
    rendering.draw_animation { animation = "robot_sparks", target = robot, target_offset = { 0, -0.9 }, time_to_live =
        time_to_mine, surface = robot.surface }
    game.pollution_statistics.on_flow(robot.name, peppermint.POLLUTION * time_to_mine / 60)
    local data = { game.tick + time_to_mine, robot }
    table.insert(global.entities, data)
    table.insert(global.tick_tock, { game.tick + 1, data })
    --game.print("sleeping unit for " .. tostring(time_to_mine) )
end

function activate_robot()
    for i = #global.entities, 1, -1 do
        if game.tick >= global.entities[i][1] then
            if global.entities[i][2].valid then
                global.entities[i][2].active = true
            end
            table.remove(global.entities, i)
        end
    end
end

function tock_tick()
    for i = #global.tick_tock, 1, -1 do
        local data = global.tick_tock[i][2]
        if game.tick >= global.tick_tock[i][1] then
            if data[2].valid then
                data[2].active = false
            end
            table.remove(global.tick_tock, i)
        end
    end
end

function nougat.bake()
    global.items = {}
    --Migration for 2.1.0
    global.entities = global.entities or {} --array of form {game_tick, robot}
    global.tick_tock = global.tick_tock or {}
    --End migration
    for k, v in pairs(game.entity_prototypes) do
        if v.type == "resource" then
            if v.mineable_properties.required_fluid == nil and not v.infinite_resource and not (v.resource_category == "basic-fluid") then
                table.insert(global.nougat.easy_ores, v.name)
                --This logic does not account for mining operations that returns more or less than 1 of an item.
                if v.mineable_properties.products then
                    for n, p in pairs(v.mineable_properties.products) do
                        if p.type == "item" then
                            global.items[p.name] = math.max(global.items[p.name] or 1, v.mineable_properties.mining_time)
                        end
                    end
                end
            end
        end
    end
end

function nougat.register(entity)
    if not (entity and entity.valid and entity.type == "roboport") then return end
    if not (entity.logistic_cell and entity.logistic_cell.valid) then return end

    local roboport = entity
    local radius = nougat.how_many_licks(roboport)
    if not radius then --Some mods use weird roboports.
        return
    end

    local count = entity.surface.count_entities_filtered { name = global.nougat.easy_ores, area = {
        { roboport.position.x - radius,     roboport.position.y - radius },
        { roboport.position.x + radius - 1, roboport.position.y + radius - 1 } } }
    --game.print("Found number of ores: " .. count)
    if not global.nougat.forces[entity.force.name] then
        global.nougat.forces[entity.force.name] = {
            roboports = {},
            index = 1
        }
    end

    if count > 0 then
        table.insert(global.nougat.forces[entity.force.name].roboports, entity)
    end
end

function nougat.how_many_licks(entity)
    local radius
    if entity and entity.valid and entity.logistic_cell then
        if not settings.global["nougat use construction range"].value then
            radius = entity.logistic_cell.logistic_radius
        else
            radius = entity.logistic_cell.construction_radius
        end
    end
    if radius and radius > 0 then
        return radius
    else --Invalid entity/roboport
        return nil
    end
end

script.on_init(function()
    if game.active_mods["Nougat_Mining"] then
        settings.global["nougat mode"].value = true
    end
    nougat.bake()
end)

script.on_configuration_changed(nougat.bake)

script.on_event(defines.events.on_player_selected_area, peppermint.mark)
script.on_event(defines.events.on_player_alt_selected_area, function(event)
    event.alt = true
    peppermint.mark(event)
end)
-- script.on_nth_tick(601, peppermint.gc)
script.on_nth_tick(61, peppermint.stretch)
script.on_nth_tick(67, nougat.stretch)
script.on_event(
    { defines.events.on_robot_built_entity, defines.events.on_built_entity, defines.events.script_raised_built,
        defines.events.script_raised_revive }, function(event)
        local entity = event.created_entity or event.entity
        nougat.register(entity)
    end)

script.on_event(defines.events.on_robot_pre_mined, delay_deconstruction, { { filter = "name", name = "item-on-ground" } })
script.on_event(defines.events.on_tick, function()
    activate_robot()
    tock_tick()
end)

script.on_event(defines.events.on_runtime_mod_setting_changed, function(event)
    if event.setting == "nougat use construction range" or event.setting == "nougat mode" then
        if not settings.global["nougat mode"].value then return end
        global.nougat.forces = {}
        --global.nougat.pollution = 9 * 0.9
        for _, surface in pairs(game.surfaces) do
            for __, roboport in pairs(surface.find_entities_filtered { type = "roboport" }) do
                nougat.register(roboport)
            end
        end
    end
end)
