--Add items for fluid-requiring ores.
for name, resource in pairs(data.raw.resource) do
    if resource.minable and resource.minable.required_fluid then
        local has_item = false
        local robot = data.raw["construction-robot"]["construction-robot"]
        local item
        if resource.minable.result then
            has_item = true
        end
        --In case any funky thing has fluid and item outputs...
        if resource.minable.results then
            for _, result in pairs(resource.minable.results) do
                if result.type == "item" then
                    has_item = true
                    item = data.raw.item[result.name]
                    break
                end
            end
        end
        if has_item then
            local item_name = name .. "-taffy"
            data:extend{
                {
                    type="item",
                    name=item_name,
                    icon = resource.icon,
                    icons = resource.icons,
                    localised_name = {"item-name.peppermint-taffy", resource.localised_name or {"item-name." .. name}},
                    localised_description = {"item-description.peppermint-taffy", resource.minable.required_fluid.localised_name or {"fluid-name." .. resource.minable.required_fluid}, resource.localised_name or {"item-description." .. name}},
                    icon_size = resource.icon_size, icon_mipmaps = resource.icon_mipmaps,
                    subgroup = "raw-resource",
                    order = "p" .. name,
                    stack_size = 50
                },
                {
                    type="recipe",
                    name=item_name,
                    category = "chemistry",
                    enabled = false, --Enabled via script
                    localised_name = {"recipe-name.peppermint-taffy", resource.localised_name or {"item-name." .. name}},
                    localised_description = {"item-description.peppermint-taffy", resource.minable.required_fluid.localised_name or {"fluid-name." .. resource.minable.required_fluid}, resource.localised_name or {"item-description." .. name}},
                    --Icons would normally go here.
                    ingredients = {
                        { type="item", name=item_name, amount=1 },
                        { type="fluid", name=resource.minable.required_fluid, amount=1 },
                    },
                    result = resource.minable.result,
                    results = resource.minable.results
                }
            }
            --Go back and do the icon.
            local icons
            if resource.icons then icons = util.table.deepcopy(resource.icons)
            elseif resource.icon then icons = {{icon=resource.icon, icon_size=resource.icon_size, icon_mipmaps=resource.icon_mipmaps}}
            else icons = {{icon=data.raw.item["stone"].icon, icon_size=data.raw.item["stone"].icon_size, icon_mipmaps=data.raw.item["stone"].icon_mipmaps}}
            end
            table.insert(icons, {icon=robot.icon, scale=0.25, icon_size=robot.icon_size, shift = {-robot.icon_size*1/8, robot.icon_size*1/8}})
            data.raw.item[item_name].icons = icons
            data.raw.recipe[item_name].icons = icons
        end
    end
end